#!/usr/bin/python
# -*- coding: utf-8 -*- 

################################################################################
#
# Servidor Tablon - Reiniciador
# Asignatura Computación paralela
# Javier Fresno, 2015
#
################################################################################


import subprocess
import time
import signal
import sys
import os


# Time to restart (in seconds)
RESTARTTIME = 60 * 60

# The command
cmd = ['python','server.py',str(RESTARTTIME)]



# Function to check if the server has changed
# It is used to restart the server if changes
# have been done
last_time = None
def has_server_changed():
	global last_time
	newtime = os.stat('server.py').st_mtime
	if last_time != newtime:
		last_time = newtime
		return True
	return False
# Init
has_server_changed()



sigint = False

def quit_gracefully(*args):
	global sigint
	sigint = True


signal.signal(signal.SIGINT, quit_gracefully)


while True:

	# Wait for Control+C
	try:

		# Start the server
		print "Reiniciador: START"
		process = subprocess.Popen(cmd)

		# Sleep
		start = time.time()
		while time.time() - start < RESTARTTIME:
			time.sleep(2)
			if has_server_changed():
				print "Reiniciador: SERVER HAS CHANGED"
				break
			if sigint:
				raise "Reiniciador SIGINT"


		# Kill the server
		print "Reiniciador: SIGINT"
		process.send_signal(signal.SIGINT)

		# Wait a bit to let the server close normally
		times = 10
		while process.poll() == None:
			time.sleep(1)
			times -= 1
			if times < 0:
				break

		# Kill the server
		if process.poll() == None:
			print "Reiniciador: KILL"
			process.terminate()
			time.sleep(1)
			process.kill()

		time.sleep(5)

		print "Reiniciador: END LOOP"

	except:
		print "Reiniciador: KILLLL"
		try:
			process.kill()
		except:
			pass
		sys.exit(-1)








